
#    Note:  This is loaded into the namespace LOST

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable ShowLogFlag 0

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable Line_count 0

    variable JS ""

    variable allmodules 0
    variable module_list ""
      set BAK $::AIDA::FEE64   ;#   save
	foreach item $::AIDA::ModuleMenu {
		set ::AIDA::FEE64 $item	
    		variable Name$item "$item"
     		variable ASIC$item [ ReadAIDARegister 0x30C ]
     		variable CT$item [ ReadAIDARegister 0x311 ]
     		variable DISC$item [ ReadAIDARegister 0x503 ]

	}

      set ::AIDA::FEE64 $BAK   ;#   restore

   proc  show_variables {} {
       variable allmodules

       InsertLog "FEE64 = $::AIDA::FEE64"
       InsertLog "all modules = $allmodules"
   }


   proc do_redisplay {} {

     variable module_list
     variable allmodules 

	

      set BAK $::AIDA::FEE64   ;#   save

	foreach item $::AIDA::ModuleMenu {
 		set ::AIDA::FEE64 $item		
     		variable ASIC$item 
		set vl0 [ set ASIC$item ]
		set vl1 [ ReadAIDARegister 0x30C ]
		if { $vl0 == $vl1 } {
			set ASIC$item "<font color=green>$vl0<\/font>"
		} else {
			set ASIC$item"<font color=red>$vl1<\/font>"
		}

     		variable CT$item 
 		set vl0 [ set CT$item ]
		set vl1 [ ReadAIDARegister 0x311 ]
		if { $vl0 == $vl1 } {
			set CT$item "<font color=green>$vl0<\/font>"
		} else {
			set CT$item"<font color=red>$vl1<\/font>"
		}
    		variable DISC$item 
		set vl0 [ set DISC$item ]
		set vl1 [ ReadAIDARegister 0x503 ]
		if { $vl0 == $vl1 } {
			set DISC$item "<font color=green>$vl0<\/font>"
		} else {
			set DISC$item"<font color=red>$vl1<\/font>"
		}

	}
      set ::AIDA::FEE64 $BAK   ;#   restore


   }

   proc do_setOpt900 {i vl} {
      variable allmodules

    }

   proc FORCE {} {
      variable allmodules
      variable module_list

   }

   proc  do_click {}  {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {

              set w [first [lindex $cgidata 1]]
              set vl [second [lindex $cgidata 1]]

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   MODULE     {set ::AIDA::FEE64 $vl}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   OPT900     {do_setOpt900 [second [lindex $cgidata 1]] [third [lindex $cgidata 1]]}
                   EXPERT   {$vl}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
        }
        do_redisplay
     }

    do_redisplay

}   ;# end of if {$started == 0}




